<?
  function photosreaddirectory($rep, $extensions)
  {  // Renvoie un array trie des fichiers et repertoires du repertoire $rep
     // Extensions est un tableau de toutes les extensions de fichier a afficher CASE SENSITIVE
    if (!is_dir($rep)) return ; // Retourne vide si on n'a pas acces au repertoire
    if ($handle = opendir($rep))
    {
      while (false !== ($files = readdir($handle)))
      {
        $path_parts = pathinfo($files);
        if (!isset($path_parts["extension"])) continue;
        if ($files[0] != "." && is_file($rep."/".$files) 
        && in_array($path_parts["extension"], $extensions)
        && !is_link ($rep."/".$files)
        ) $arrayfile[]=$files;
      }
      // Vire les fichiers caches et les . et ..
      closedir($handle);
      if (empty($arrayfile)) return; // Retourne vide si le repertoire est vide.
      sort($arrayfile); 
      reset($arrayfile);
      return ($arrayfile);
    }
  }

  function photoreadlinks($rep, $extensions)
  { // Renvoie un array trie des liens disponibles du repertoire $rep
    // Extensions est un tableau de toutes les extensions de fichier a afficher CASE SENSITIVE
    if (!is_dir($rep)) return ; // Retourne vide si on n'a pas acces au repertoire
    if ($handle = opendir($rep))
    {
      while (false !== ($files = readdir($handle)))
      {
        $path_parts = pathinfo($files);
        if (!isset($path_parts["extension"])) continue;
        if ($files[0] != "." 
        && is_file($rep."/".$files)
        && $path_parts["extension"]=="rep"
        && is_link ("$rep/$files")
        ) $arrayfile[]=$files;
      }
      // Vire les fichiers caches et les . et ..
      closedir($handle);
      if (empty($arrayfile)) return; // Retourne vide si le repertoire est vide.
      sort($arrayfile);
      reset($arrayfile);
      return ($arrayfile);
    }
  }


  function photolistedirs ($repphotos, $repautorises)
  { // Renvoie la liste des repertoires disponibles dans le repertoire $rep
    // Tries par ordre alphabetique
    // Retourne vide si on n'a pas acces au repertoire
    if (!is_dir($repphotos)) return ; 
    if ($handle = opendir($repphotos))
    {
      while (false !== ($file=readdir($handle)))
      {
        // Vire les fichiers caches et les . et ..
        if ($file[0] != "." && is_dir($repphotos.$file) 
            && in_array($file, $repautorises)
          ) 
          {
          $arrayrep[]=$file;
        }
      }
      closedir($handle);
      if (empty($arrayrep)) return; // Retourne vide si le repertoire est vide.
      sort($arrayrep);
      reset($arrayrep);
      return ($arrayrep);
    }
  }
  
  function affichethumbails($filearray, $thumnbX, $photosweb, $photos, $admin)
  {
    // On affiche la page des thumbails
    // Param : $filearray    => Liste des fichiers
    //         $thumnbX      => Nombre de thumbails par ligne
    //         $photosweb    => URL du repertoire des photos (Relatif a photos) 
    //         $photos       => Repertoire des photos (pour les infos tech)
    //         $admin        => Lien pour modifier les photos
    global $conf;
    echo "<div class='thumbails'>\n";
    echo "  <table>\n";
    $X=1;
    $i=0;
    $proprierror=0;
    if (substr($photosweb,-1)=="/") $photosweb=substr($photosweb,0,-1);
    foreach ($filearray as $file)
    {
      if ($X==1) echo "    <tr align='center'>\n";
      echo "      <td valign='top'>";
      /////// C'est ici qu'il faut mettre quelquechose pour chaque image //////
      $path_parts = pathinfo($file);
      if (isset($path_parts["extension"]) && $file[0] != "." && 
          is_file("$photos/$photosweb/$file"))
      {
        if (in_array($path_parts["extension"], $conf["filmsext"]))
        {
          // Un film !! : Download seul
          echo "<a href='image.php?image=".rawurlencode("$photosweb/$file").
               "'>";
          echo "<img src='thum.php?image=".rawurlencode("$photosweb/$file").
               "' alt=''/></a>";
          echo "<br/>";
          echo "$file<br/>\n";
          echo intval (filesize ("$photos/$photosweb/$file")/1000000).
               " Mo<br/>";
        }
        elseif (in_array($path_parts["extension"], $conf["imagesext"]))
        {
          // Une image
          echo "<a href='slide.php?pic=".$i."&amp;rep=".rawurlencode($photosweb)
              ."'>";
          echo "<img src='thum.php?image=".rawurlencode("$photosweb/$file").
               "' alt=''/></a>";
          echo "<br/>";
          list($width, $height, $type, $attr) = 
                                       getimagesize("$photos/$photosweb/$file");
          echo "$file<br/>($width x $height)<br/>";
          if ($admin)
          {
            if  (!is_writeable("$photos/$photosweb/$file"))
              $proprierror=1;
            else
              echo " <a href='modif.php?pic=$i&amp;rep=".
                   rawurlencode($photosweb)."' target='blank'>Modifier</a>";
            if ($photosweb!="." && 
                @realpath(readlink("$photos/$photosweb.rep"))!=
                 realpath("$photos/$photosweb/$file"))
            { // Cette photo peut-etre representative
              echo " <a href='modif.php?pic=$i&amp;rep=".
                   rawurlencode($photosweb).
                   "&amp;representation=1'>Représentation</a>";
            }
          }
          // Seules les photos sont incrementees
          $i++;
        }
        else
        {
          // Autre chose, on saute
          continue;
        }
      }
      // ///////////////// Fin de l'ici ////////////////////////////////////////////////////
      echo "</td>\n";
      if ($X==$thumnbX) 
      { 
        echo "    </tr>\n";
        $X=1;
      }
      else     
        $X++;
    }
    // Ici, on n'a pas forcement fini correctement la table :
    if ($X!=1)
    {
      for ($i=$X; $i<=$thumnbX; $i++)
        echo "      <td>&nbsp;</td>\n";
      echo "    </tr>\n";
    }
    // OK, maintenant tout est OK, on ferme
    echo "  </table>\n";

    if ($proprierror)  
    {
      $arrayuid=posix_getpwuid(posix_getuid());
      echo "<span class='photoserror'>Les photos non modifiables ne peuvent pas être écrites par ".$arrayuid["name"]."</span><br/>\n";
    }
    echo "</div>\n";
  }

  function rotate($imagePath,$rtt)
  {
    //$imagePath - path to your image; function will save rotated image overwriting the old one
    //$rtt - should be 90 or -90 - cw/ccw
    if ($rtt=="90") $rtt="-9";
    elseif ($rtt=="-90") $rtt="-2";
    else die ("EXIT : rotate active avec un argument rtt incorrect !!");
    // Renvoie le return Code de la fonction
    exec ("exiftran -gi $rtt \"$imagePath\"" ,$array, $rc);
    touch ($imagePath);
    return $rc;
  }

  function redimension($fileimage, $filethumbail, $width)
  {
    // On redimensionne l'image $fileimage a la taille $thumbsize dans le thumbail $filethumbail
    // ATTENTION : A n'utiliser QUE sur les miniatures, PAS sur les vraies 
    // photos : perte des fiches EXIF
    //echo "On redimensionne l'image $fileimage à la taille $thumbsize dans la thumbail $filethumbail<BR>\n";
    $im    = imagecreatefromjpeg($fileimage);
    $orange = imagecolorallocate($im, 220, 210, 60);
    $px    = (imagesx($im) - 7.5 * strlen($string)) / 2;
 
    $old_x=imageSX($im);
    $old_y=imageSY($im);
 
    $new_w=(int)($width);
    if (($new_w<=0) or ($new_w>$old_x)) {
      $new_w=$old_x;
    }
 
    $new_h=($old_x*($new_w/$old_x));
 
    if ($old_x > $old_y) {
        $thumb_w=$new_w;
        $thumb_h=$old_y*($new_h/$old_x);
 
    }
    if ($old_x < $old_y) {
        $thumb_w=$old_x*($new_w/$old_y);
        $thumb_h=$new_h;
    }
    if ($old_x == $old_y) {
        $thumb_w=$new_w;
        $thumb_h=$new_h;
    }
      $thumb=ImageCreateTrueColor($thumb_w,$thumb_h);
      imagecopyresized($thumb,$im,0,0,0,0,$thumb_w,$thumb_h,$old_x,$old_y);
 
    imagejpeg($thumb,$filethumbail,90);
    imagedestroy($thumb);
  }
?>
